

#include "BUILTIN.h"
extern OBJ _ACom_47(OBJ,OBJ);extern OBJ __ACom_47;
extern OBJ __AFileSystem_2;
extern OBJ __AFileSystem_4;
extern OBJ __AFileSystem_6;
extern OBJ __AFileSystem_8;
extern OBJ __AFileSystem_10;
extern OBJ __AFileSystem_12;
extern OBJ __AFileSystem_14;
extern OBJ __AFileSystem_16;
extern OBJ __AFileSystem_18;
extern OBJ __AFileSystem_54;
extern OBJ _AFileSystem_59(OBJ,OBJ);extern OBJ __AFileSystem_59;
extern OBJ _AFileSystem_78(OBJ);extern OBJ __AFileSystem_78;
extern OBJ _AFileSystem_192(OBJ,OBJ);extern OBJ __AFileSystem_192;
extern OBJ _AFileSystem_194(OBJ,OBJ);extern OBJ __AFileSystem_194;

#include "Nat.h"
extern OBJ __ASeq_6;
extern OBJ __ATime_17;
extern OBJ _ATime_24(OBJ,OBJ);extern OBJ __ATime_24;
extern OBJ _AUserAndGroup_12(OBJ);extern OBJ __AUserAndGroup_12;
extern OBJ _AUserAndGroup_23(OBJ);extern OBJ __AUserAndGroup_23;

#include "Denotation.h"

#include "Char.h"

#include "Real.h"
extern OBJ _AStringConv_1(OBJ);extern OBJ __AStringConv_1;
extern OBJ _AStringFormat_1(OBJ,OBJ);extern OBJ __AStringFormat_1;
extern OBJ _ABTUnion_23(OBJ,OBJ);extern OBJ __ABTUnion_23;
extern OBJ _ABTUnion_29(OBJ,OBJ);extern OBJ __ABTUnion_29;
extern OBJ _ABTUnion_36(OBJ);extern OBJ __ABTUnion_36;
extern OBJ _AComCompose_5(OBJ,OBJ);extern OBJ __AComCompose_5;
extern OBJ _ATimeConv_6(OBJ,OBJ);extern OBJ __ATimeConv_6;
extern OBJ _AFileSystemConv_3(OBJ);extern OBJ __AFileSystemConv_3;
extern OBJ _AFileSystemConv_5(OBJ);extern OBJ __AFileSystemConv_5;

#include "Int.h"

#include "Array.h"
OBJ __AFileSystemFun_1; /* rwxrwxrwx */
OBJ __AFileSystemFun_2; /* rw_rw_rw_ */
OBJ __AFileSystemFun_3; /* rwxrwxr_x */
OBJ __AFileSystemFun_4; /* rw_rw_r__ */
OBJ __AFileSystemFun_5; /* rwxr_xr_x */
OBJ __AFileSystemFun_6; /* rw_r__r__ */
OBJ __AFileSystemFun_7; /* rwxrwx___ */
OBJ __AFileSystemFun_8; /* rw_rw____ */
OBJ __AFileSystemFun_9; /* rwxr_x___ */
OBJ __AFileSystemFun_10; /* rw_r_____ */
OBJ __AFileSystemFun_11; /* rwx______ */
OBJ __AFileSystemFun_12; /* rw_______ */
OBJ __AFileSystemFun_13; /* ___rwxrwx */
OBJ __AFileSystemFun_14; /* ____w_rwx */
OBJ __AFileSystemFun_15; /* ____w__w_ */
OBJ __AFileSystemFun_16; /* ______rwx */
OBJ __AFileSystemFun_17; /* _______w_ */
OBJ __AFileSystemFun_18; /* _________ */
extern OBJ _AFileSystemFun_19(OBJ);OBJ __AFileSystemFun_19; /* ls_dlg */
OBJ __AFileSystemFun_20; /* ls_dlg'20 */
OBJ __AFileSystemFun_21; /* ls_dlg'21 */
OBJ __AFileSystemFun_22; /* ls_dlg'22 */
OBJ __AFileSystemFun_23; /* ls_dlg'23 */
extern OBJ _AFileSystemFun_24(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __AFileSystemFun_24; /* ls_dlg'24 */
extern OBJ _AFileSystemFun_25(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __AFileSystemFun_25; /* ls_dlg'25 */
extern OBJ _AFileSystemFun_26(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __AFileSystemFun_26; /* ls_dlg'26 */
extern OBJ _AFileSystemFun_27(OBJ,OBJ);OBJ __AFileSystemFun_27; /* ls_dlg'27 */

extern OBJ _AFileSystemFun_19(OBJ x1) /* ls_dlg */
{OBJ r;
 CPCLS(__AFileSystemFun_27,1);
 CPPRD(x1,1);
 {OBJ x2;OBJ x3;
  x2=_AFileSystem_78(x1);
  x3=(*(OBJ(*)(OBJ,OBJ))METHOD(__AFileSystemFun_27,1))(__AFileSystemFun_27,x1);
  r=_AComCompose_5(x2,x3);}
 return r;}

extern OBJ _AFileSystemFun_24(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6,OBJ x7,OBJ x8,OBJ x9) /* ls_dlg'24 */
{OBJ r;
 {OBJ x15;OBJ x17;OBJ x10;OBJ x11;OBJ x12;OBJ x13;OBJ x18;OBJ x19;OBJ x20;OBJ x21;OBJ x22;OBJ x48;OBJ x34;OBJ x23;OBJ x24;OBJ x49;OBJ x50;OBJ x51;OBJ x52;OBJ x53;OBJ x54;OBJ x55;OBJ x56;OBJ x57;OBJ x58;OBJ x59;OBJ x60;OBJ x61;OBJ x62;OBJ x63;OBJ x64;
  if(ISPRM(x3)){
   x15=__ABUILTIN_5;
  }else{
   x15=__ABUILTIN_3;}
  if(ISPRM(x2)){
   COPY(x4,1);
   x17=__ABUILTIN_5;
  }else{
   COPY(x4,1);
   x17=__ABUILTIN_3;}
  x10=inline_c_real((double)(60));
  CPPRD(x10,1);
  x11=inline_c_real((double)(24));
  x12=inline_c_real((double)(30.42));
  x13=inline_c_real((double)(6));
  x18=_ABTUnion_36(x1);
  AReal_61(x10,x10,x19);
  x20=_ATime_24(x9,x4);
  x21=_AFileSystemConv_3(x5);
  x22=_AFileSystemConv_5(x6);
  if(ISTGPRM(x17,1)){
   FREE(x2,1);
   CPPRD(__AFileSystemFun_20,1);
   x48=__AFileSystemFun_20;
  }else{
   if(ISPRD(x2)){
    {OBJ x42=FLD1(x2,1);
     if(EXPRD(x2,1)){
      DSPRDF(x2);
     }else{
      CPPRD(x42,1);
      FRPRD(x2,1);}
     {OBJ x43=FLD1(x42,1);
      if(EXPRD(x42,1)){
       x48=x43;
       FLD1(x42,1)=NIL;DSPRD(x42);
      }else{
       CPPRD(x43,1);
       x48=x43;
       FRPRD(x42,1);}}}
   }else{
    HLT("Option at <unknown> : undefined selection cont\'Option:option->data");}}
  if(ISTGPRM(x15,1)){
   FREE(x3,1);
   CPPRD(x19,1);
   CPPRD(x20,1);
   CPPRD(__AFileSystemFun_20,1);
   x34=__AFileSystemFun_20;
  }else{
   if(ISPRD(x3)){
    {OBJ x30=FLD1(x3,1);
     if(EXPRD(x3,1)){
      DSPRDF(x3);
     }else{
      CPPRD(x30,1);
      FRPRD(x3,1);}
     {OBJ x31=FLD1(x30,1);
      if(EXPRD(x30,1)){
       x34=x31;
       FLD1(x30,1)=NIL;DSPRD(x30);
      }else{
       CPPRD(x31,1);
       x34=x31;
       FRPRD(x30,1);}
      CPPRD(x19,1);
      CPPRD(x20,1);}}
   }else{
    HLT("Option at <unknown> : undefined selection cont\'Option:option->data");}}
  AReal_61(x19,x11,x23);
  AReal_65(x19,x24);
  AReal_61(x23,x12,x49);
  AReal_94(x20,x24,x50);
  AReal_61(x49,x13,x51);
  if(ISTGPRM(x50,1)){
   FRPRD(x20,1);
   FRPRD(x51,1);
   x52=__ABUILTIN_5;
  }else{
   AReal_95(x20,x51,x52);}
  if(ISTGPRM(x52,1)){
   CPPRD(__AFileSystemFun_21,1);
   CPPRD(__AFileSystemFun_23,1);
   CPCLS(__ACom_47,1);
   x53=_ATimeConv_6(__AFileSystemFun_21,x4);
  }else{
   CPPRD(__AFileSystemFun_22,1);
   CPPRD(__AFileSystemFun_23,1);
   CPCLS(__ACom_47,1);
   x53=_ATimeConv_6(__AFileSystemFun_22,x4);}
  x54=_ABTUnion_29(x53,x18);
  x55=_ABTUnion_23(x8,x54);
  x56=_ABTUnion_29(x34,x55);
  x57=_ABTUnion_29(x48,x56);
  x58=_ABTUnion_23(x7,x57);
  x59=_ABTUnion_29(x22,x58);
  x60=_ABTUnion_29(x21,x59);
  x61=_AStringFormat_1(__AFileSystemFun_23,x60);
  x62=_AStringConv_1(x61);
  PRD(1,0,x63);FLD(x63,1)=x62;
  x64=(*(OBJ(*)(OBJ,OBJ))METHOD(__ACom_47,1))(__ACom_47,x63);
  PRD(2,0,r);FLD(r,1)=x64;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AFileSystemFun_25(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6,OBJ x7,OBJ x8) /* ls_dlg'25 */
{OBJ r;
 CPCLS(__AFileSystemFun_24,1);
 CPPRD(__ATime_17,1);
 {OBJ x9;
  x9=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__AFileSystemFun_24,8))(__AFileSystemFun_24,x1,x2,x8,x3,x4,x5,x6,x7);
  r=_AComCompose_5(__ATime_17,x9);}
 return r;}

extern OBJ _AFileSystemFun_26(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6,OBJ x7,OBJ x8) /* ls_dlg'26 */
{OBJ r;
 CPCLS(__AFileSystemFun_25,1);
 {OBJ x9;OBJ x10;
  x9=_AUserAndGroup_23(x2);
  x10=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__AFileSystemFun_25,7))(__AFileSystemFun_25,x1,x8,x3,x4,x5,x6,x7);
  r=_AComCompose_5(x9,x10);}
 return r;}

extern OBJ _AFileSystemFun_27(OBJ x1,OBJ x2) /* ls_dlg'27 */
{OBJ r;
 {OBJ x89=FLD1(x2,1);OBJ x90=FLD1(x2,2);OBJ x93=FLD1(x2,5);OBJ x94=FLD1(x2,6);OBJ x95=FLD1(x2,7);OBJ x96=FLD1(x2,8);OBJ x99=FLD1(x2,11);
  if(EXPRD(x2,1)){
   FLD1(x2,2)=NIL;FLD1(x2,6)=NIL;FLD1(x2,7)=NIL;FLD1(x2,11)=NIL;DSPRD(x2);
  }else{
   COPY(x90,1);COPY(x94,1);COPY(x95,1);COPY(x99,1);
   FRPRD(x2,1);}
  CPCLS(__AFileSystemFun_26,1);
  {OBJ x100;OBJ x101;
   x100=_AUserAndGroup_12(x94);
   x101=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__AFileSystemFun_26,7))(__AFileSystemFun_26,x1,x95,x99,x89,x90,x93,x96);
   r=_AComCompose_5(x100,x101);}}
 return r;}





static void ___AFileSystemFun_5()
{
 COPY(__AFileSystemFun_9,1);
 {OBJ x1;
  x1=_AFileSystem_59(__AFileSystem_6,__AFileSystem_2);
  __AFileSystemFun_5=_AFileSystem_194(__AFileSystemFun_9,x1);}}




static void ___AFileSystemFun_9()
{
 COPY(__AFileSystemFun_11,1);
 {OBJ x1;
  x1=_AFileSystem_59(__AFileSystem_12,__AFileSystem_8);
  __AFileSystemFun_9=_AFileSystem_194(__AFileSystemFun_11,x1);}}




static void ___AFileSystemFun_13()
{
 COPY(__AFileSystemFun_14,1);
 {OBJ x1;
  x1=_AFileSystem_59(__AFileSystem_12,__AFileSystem_8);
  __AFileSystemFun_13=_AFileSystem_194(__AFileSystemFun_14,x1);}}



static void ___AFileSystemFun_16()
{
 COPY(__AFileSystemFun_17,1);
 {OBJ x1;
  x1=_AFileSystem_59(__AFileSystem_6,__AFileSystem_2);
  __AFileSystemFun_16=_AFileSystem_194(__AFileSystemFun_17,x1);}}



static OBJ _mt_8_0_7(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5,OBJ t6,OBJ t7) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,7);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 FLDCLS(r,4)=t4;
 FLDCLS(r,5)=t5;
 FLDCLS(r,6)=t6;
 FLDCLS(r,7)=t7;
 return r;}

static OBJ _mt_8_7_1(OBJ t,OBJ t1) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  COPY(FLDCLS(t,4),1);
  COPY(FLDCLS(t,5),1);
  COPY(FLDCLS(t,6),1);
  COPY(FLDCLS(t,7),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),FLDCLS(t,6),FLDCLS(t,7),t1);
 return r;}
static OBJ _mt_8_7_1_l(OBJ t,OBJ t1) 
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),FLDCLS(t,6),FLDCLS(t,7),t1);
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  DCCLS(t,1);
  FLDCLS(t,1)=NIL;FLDCLS(t,2)=NIL;FLDCLS(t,3)=NIL;FLDCLS(t,4)=NIL;FLDCLS(t,5)=NIL;FLDCLS(t,6)=NIL;FLDCLS(t,7)=NIL;
  COPY(r,1);LZYCLS(t,r);}
 return r;}

static OBJ _mt_9_0_8(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5,OBJ t6,OBJ t7,OBJ t8) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,8);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 FLDCLS(r,4)=t4;
 FLDCLS(r,5)=t5;
 FLDCLS(r,6)=t6;
 FLDCLS(r,7)=t7;
 FLDCLS(r,8)=t8;
 return r;}

static OBJ _mt_9_8_1(OBJ t,OBJ t1) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  COPY(FLDCLS(t,4),1);
  COPY(FLDCLS(t,5),1);
  COPY(FLDCLS(t,6),1);
  COPY(FLDCLS(t,7),1);
  COPY(FLDCLS(t,8),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),FLDCLS(t,6),FLDCLS(t,7),FLDCLS(t,8),t1);
 return r;}
static OBJ _mt_9_8_1_l(OBJ t,OBJ t1) 
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),FLDCLS(t,6),FLDCLS(t,7),FLDCLS(t,8),t1);
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  DCCLS(t,1);
  FLDCLS(t,1)=NIL;FLDCLS(t,2)=NIL;FLDCLS(t,3)=NIL;FLDCLS(t,4)=NIL;FLDCLS(t,5)=NIL;FLDCLS(t,6)=NIL;FLDCLS(t,7)=NIL;FLDCLS(t,8)=NIL;
  COPY(r,1);LZYCLS(t,r);}
 return r;}

init_AFileSystemFun()
{
 static int visited=0; if(visited) return; visited=1;
 init_ACom();
 init_AFileSystem();
 init_AVoid();
 init_ANat();
 init_AString();
 init_ASeq();
 init_ATime();
 init_AUserAndGroup();
 init_ADenotation();
 init_AOption();
 init_ASet();
 init_AChar();
 init_AReal();
 init_AStringConv();
 init_AStringFormat();
 init_ABTUnion();
 init_AComCompose();
 init_ATimeConv();
 init_AFileSystemConv();
 init_AInt();
 init_ASeqMap();
 init_AArray();
 init_AOptionMap();
 init_AStringMapSeq();
 CLS(2,_AFileSystemFun_27,__AFileSystemFun_27);
 CLS(8,_AFileSystemFun_26,__AFileSystemFun_26);
 CLS(8,_AFileSystemFun_25,__AFileSystemFun_25);
 CLS(9,_AFileSystemFun_24,__AFileSystemFun_24);
 DEN("%d%d %3n %-8d %-8d %8n %d %d",__AFileSystemFun_23);
 DEN("%b %e %k:%M",__AFileSystemFun_22);
 DEN("%b %e  %Y",__AFileSystemFun_21);
 DEN("<\?\?\?\?\?\?>",__AFileSystemFun_20);
 CLS(1,_AFileSystemFun_19,__AFileSystemFun_19);
 MTH(8,0,7,_mt_8_0_7);LZYMTH(8,0,7,_mt_8_0_7);
 MTH(8,7,1,_mt_8_7_1);LZYMTH(8,7,1,_mt_8_7_1_l);
 MTH(9,0,8,_mt_9_0_8);LZYMTH(9,0,8,_mt_9_0_8);
 MTH(9,8,1,_mt_9_8_1);LZYMTH(9,8,1,_mt_9_8_1_l);
 __AFileSystemFun_12=_AFileSystem_59(__AFileSystem_18,__AFileSystem_16);
 COPY(__AFileSystemFun_12,1);
 __AFileSystemFun_11=_AFileSystem_192(__AFileSystemFun_12,__AFileSystem_14);
 ___AFileSystemFun_9();
 ___AFileSystemFun_5();
 COPY(__AFileSystemFun_5,1);
 __AFileSystemFun_3=_AFileSystem_192(__AFileSystemFun_5,__AFileSystem_10);
 COPY(__AFileSystemFun_3,1);
 __AFileSystemFun_1=_AFileSystem_192(__AFileSystemFun_3,__AFileSystem_4);
 COPY(__AFileSystemFun_12,1);
 __AFileSystemFun_10=_AFileSystem_192(__AFileSystemFun_12,__AFileSystem_12);
 COPY(__AFileSystemFun_10,1);
 __AFileSystemFun_8=_AFileSystem_192(__AFileSystemFun_10,__AFileSystem_10);
 COPY(__AFileSystemFun_8,1);
 __AFileSystemFun_4=_AFileSystem_192(__AFileSystemFun_8,__AFileSystem_6);
 COPY(__AFileSystemFun_4,1);
 __AFileSystemFun_2=_AFileSystem_192(__AFileSystemFun_4,__AFileSystem_4);
 COPY(__AFileSystemFun_10,1);
 __AFileSystemFun_6=_AFileSystem_192(__AFileSystemFun_10,__AFileSystem_6);
 COPY(__AFileSystemFun_9,1);
 __AFileSystemFun_7=_AFileSystem_192(__AFileSystemFun_9,__AFileSystem_10);
 COPY(__AFileSystem_54,1);
 __AFileSystemFun_18=__AFileSystem_54;
 COPY(__AFileSystemFun_18,1);
 __AFileSystemFun_17=_AFileSystem_192(__AFileSystemFun_18,__AFileSystem_4);
 ___AFileSystemFun_16();
 COPY(__AFileSystemFun_16,1);
 __AFileSystemFun_14=_AFileSystem_192(__AFileSystemFun_16,__AFileSystem_10);
 ___AFileSystemFun_13();
 COPY(__AFileSystemFun_17,1);
 __AFileSystemFun_15=_AFileSystem_192(__AFileSystemFun_17,__AFileSystem_10);}

